//#define ASM
//#define STANDALONE
#include <vs1063.h>

//#define GPIO_IDATA GPIO_DATA
#define SPI_xCS2  2

	.import _SpiSendClocks
	.import _SpiSendReceiveMmc
	.import _SpiSendReceiveMmc16

#if 1

// auto u_int16 MmcCommand(register __b0 s_int16 cmd, register __d u_int32 arg)
//     register __b1 u_int16 t;

	.sect code,MmcCommand	// 57 words	-> 37
	.export _MmcCommand
_MmcCommand:
	stx A1,(I6)+1 ; sty B1,(I6)
	stx I0,(I6)+2 ; sty LR0,(I6)

//     SpiSendClocks();
//     SpiSendClocks();

	call _SpiSendClocks
	ldc GPIO_ODATA,I0
	call _SpiSendClocks
	lsr ones,b1	; ldy (I6)+1,NULL	//b1=0x7fff

//    USEX(GPIO_ODATA) &= ~SPI_xCS2; /*must be a bit before sending data*/

	lsr b1,b1	; ldx (I0),A0/*V*/	//b1 = 0x3fff
	ldc ~SPI_xCS2,A1
	and A0,A1,A1
	lsr b1,b1	; stx A1,(I0)/*V*/	//b1 = 0x1fff

//     while (SpiSendReceiveMmc(0xff00,8) != 0xff)
//	;

	// Register parameter: A1, pass by value
	// Register parameter: A0, pass by value
$0:	ldc 0xff00,A0
	call _SpiSendReceiveMmc
	ldc 8,A1

#if 0	//timeout! (maybe not actually needed..)
	add b1,ones,b1          //b1--
	ldc 0xff,a1
	jns $11
	sub a0,a1,a1    ; ldx (I6)+1,NULL // auto..
	nop
	jzc $0
$11:	ldc 8,A1

//     SpiSendReceiveMmc((cmd<<8), 8);

	call _SpiSendReceiveMmc
	ashl B0,A1,A0
#else
//     SpiSendReceiveMmc((cmd<<8), 8);

	ldc 8,A1
	call _SpiSendReceiveMmc
	ashl B0,A1,A0	; ldx (I6)+1,NULL
#endif

//     SpiSendReceiveMmc(arg>>16, 16);
//     SpiSendReceiveMmc(arg, 16);

	//ldc 16,A1
	call _SpiSendReceiveMmc16
	add D1,NULL,A0 ; ldx (I6)+1,NULL

	//ldc 16,A1
	call _SpiSendReceiveMmc16
	add D0,NULL,A0	; ldx (I6)+2,NULL

//     t = SpiSendReceiveMmc(0x9500, 8);
//     cmd = 2000;
//     while (cmd && (t & 0x80))

	ldc 8,A1
	call _SpiSendReceiveMmc
	ldc 0x9500,A0

	j LU10
	ldc 4000,B0	/* timeout increased 200 -> 2000*/
L10:
//  {
// 	t = SpiSendReceiveMmc(0xff00, 8);

	call _SpiSendReceiveMmc
	add d0,null,a0	; ldx (I6)+1,NULL

// 	cmd--;

LU10:
	add B0,ONES,B0	// update flags
	ldc 128,D0
	jzs L12
	and A0,D0,D0

	ldc 0xff00,D0
	jzc L10
	ldc 8,A1

//     }
//     return t;

	// expression in B1
L12:
	ldx (I6)-1,I0 ; ldy (I6),LR0
	jr
	ldx (I6)-1,A1 ; ldy (I6),B1

	// FUNCTION MmcCommand(): stack usage ~ 2 x (7 + 0) = 2 x 7 words
#endif

	.end
